/*
 * Example 41-3
 * The RandomCmd C command procedure.
 */

/*
* RandomObjCmd --
* This implements the random Tcl command from
* Example 41-2 using the object interface.
*/
int
RandomObjCmd(ClientData clientData, Tcl_Interp *interp,
		int objc, Tcl_Obj *CONST objv[])
{
	Tcl_Obj *resultPtr;
	int rand, error;
	int limit = 0;
	if (objc > 2) {
		Tcl_WrongNumArgs(interp, 1, objv, 
			"Usage: random ?range?");
		return TCL_ERROR;
	}
	if (objc == 2) {
		error = Tcl_GetIntFromObj(interp, objv[1], &limit);
		if (error != TCL_OK) {
			return error;
		}
	}
	rand = random();
	if (limit != 0) {
		rand = rand % limit;
	}
	resultPtr = Tcl_GetObjResult(interp);
	Tcl_SetIntObj(resultPtr, rand);
	return TCL_OK;
}


