/*
 * Example 41-5
 * The IdentityObjCmd C command procedure.
 */

/*
* IdentityObjCmd --
* This implements the identity function.
*/
int
IdentityObjCmd(ClientData clientData, Tcl_Interp *interp,
		int objc, Tcl_Obj *CONST objv[])
{
	if (objc != 2) {
		Tcl_WrongNumArgs(interp, 1, objv, 
			"Usage: identity value");
		return TCL_ERROR;
	}
	/*
	 * This increments the reference count on the argument,
	 * which could have any type.
	 */
	Tcl_SetObjResult(interp, objv[1]);
	return TCL_OK;
}


